<template>
  <nuxt-link
    :id="ID.TAB_TYPE_MOBILE_RIGHT_SIDE_BAR[menu?.TabLanguage]"
    :to="menu?.TabURL"
    class="w-full flex flex-row justify-between items-center pl-3 pr-4 py-1"
    :class="{
      'new-sidebar-menu relative': isNewMenu,
      'pl-1': $attrs['class'] === 'is-sbo',
    }"
    @click="toggleSidebar"
  >
    <div
      class="flex flex-row items-center p-0 relative pointer-events-none "
      :class="[
        isMain || isBk8 ? 'main-menu-active-container' : 'gap-2.5 py-3',
        checkActiveTab(activetab, menu) && 'menu-active',
      ]"
    >
      <div :class="isMain || isBk8 ? 'p-2' : 'w-5 h-5'">
        <svg-icon
          :svg-name="
            isUseTabLanguage
              ? menu?.TabLanguage
              : `icon-${menu?.TabType.toLowerCase().replace(' ', '-')}`
          "
          style="fill: currentColor"
          :class="[
            'icon tc-5',
            checkActiveTab(activetab, menu) && 'menu-active',
            isMain || isBk8 ? 'w-[24px] h-[24px]' : 'w-[17px] h-[17px]',
          ]"
        />
      </div>
      <span
        class="uppercase"
        :class="[
          checkActiveTab(activetab, menu) ? 'menu-active' : 'sidebar-text',
        ]"
      >
        {{
          menu?.TabType
            ? $t(menu?.TabType?.replace(" ", "_")?.toLowerCase())
            : ""
        }}
      </span>
    </div>
    <div
      v-if="hasArrow && !checkActiveTab(activetab, menu)"
      class="flex items-center m-angle-right-container"
    >
      <font-awesome-icon icon="angle-right" class="icon-angle-right" />
    </div>
  </nuxt-link>
</template>

<script lang="ts">
import { computed, defineComponent, PropType } from "vue";
import { TabInfo } from "@/models/IGetPlayableGamesResponse";
import { store } from "@/store";

export default defineComponent({
  props: {
    menu: {
      require: true,
      type: Object as PropType<TabInfo>,
    },
    hasArrow: {
      default: true,
    },
    isNewMenu: {
      type: Boolean,
      default: false,
    },
    isUseTabLanguage: {
      type: Boolean,
      default: false,
    },
  },
  setup() {
    const toggleSidebar = () => {
      store.commit("updateSidebar", !store.state.showSidebar);
    };
    const { getAssetImage } = commonHelper;
    const handleImageRender = (img: string) => {
      let src = "";
      try {
        src = getAssetImage(
          `assets/theme/new_black_theme/sidebar/${img.replace(" ", "")}.svg`
        );
      } catch (_) {
        src = "";
      }
      return src;
    };
    const route = useRoute();
    const activetab = computed(() => route.path.slice(1));
    const isMain = computed(
      () =>
        store.state.selectedThemeName === "main" &&
        !store.state.companyThemePropertiesFromApi.ThemeProperties[0].ThemeName.toLowerCase().includes(
          "bk8"
        )
    );
    const isBk8 = computed(() =>
      store.state.companyThemePropertiesFromApi.ThemeProperties[0].ThemeName.toLowerCase().includes(
        "bk8"
      )
    );
    const { fetchMessages, unreadInfo } = useMessage();
    const checkActiveTab = (active: string, menu: TabInfo) => {
      if (route.matched[0].name === "GameInitial") {
        return active
          .replace(" ", "")
          .replace("-", "")
          .toLowerCase()
          .includes(menu?.TabType.replace(" ", "").toLowerCase());
      }
      if (route.matched[0].name !== "GameInitial") {
        return (
          active.replace(" ", "").replace("-", "").toLowerCase() ===
          menu?.TabType.replace(" ", "").toLowerCase()
        );
      }
      return false;
    };
    onMounted(() => {
      if (!route.fullPath.includes("messages")) {
        fetchMessages();
      }
    });
    return {
      toggleSidebar,
      handleImageRender,
      activetab,
      checkActiveTab,
      isMain,
      isBk8,
      unreadInfo,
    };
  },
});
</script>

<style lang="scss">
.menu-active {
  color: var(--selected);
}
</style>
<style lang="scss" scoped>
.router-lint-active {
  .icon-angle-right {
    color: var(--selected);
  }
}
.new-sidebar-menu {
  &.router-link-exact-active svg {
    fill: var(--primary);
  }
  &.router-link-exact-active::before {
    content: "";
    position: absolute;
    top: 50%;
    left: 0;
    height: 100%;
    width: 2px;
    background: var(--primary);
    transform: translateY(-50%);
  }
}
.main-menu-active-container .menu-active {
  color: var(--primary);
}
.main-menu-active-container svg.menu-active {
  filter: var(--primary-filter);
}
.main-menu-active-container.menu-active::after {
  content: "";
  width: 2px;
  background-color: var(--primary);
  position: absolute;
  transform: translate(-4px, -50%);
  height: 12px;
  top: 50%;
  left: 0;
}
</style>
